clear all;
close all;

color=autumn(7);
exp="EXP61";

%%%Load analog experiment velocity
velocity=load([num2str(exp) '_trajectory_velocity.txt']);

zi=velocity(1:end,3); %depth
vi=velocity(1:end,6); %6=Vtot, 4=Vx, 5=Vz

vi=hampel(vi,20);
vi=medfilt1(vi,10);

z0(:,1)=zi(6:end,1);
v0(:,1)=vi(6:end,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Velocity filtered
out_vel=fopen([num2str(exp) '_vfZt.txt'],'w');
for i=1:length(v0(:,1))
    fprintf(out_vel,'%f12 %f12 \n', v0(i,1), z0(i,1));
end
fclose(out_vel);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%~Whole trajectory~%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Polyfit sur l'ensemble de la serie
d0(1,1)=0;
for i=2:length(z0)
   d0(i,1)=d0(i-1)+sqrt(((v0(i,1)-v0(i-1,1))*(v0(i,1)-v0(i-1,1)))+((z0(i,1)-z0(i-1,1))*(z0(i,1)-z0(i-1,1))));
end

a0=polyfit(d0,z0,4);
b0=polyfit(d0,v0,4);
%%nouveau vecteur de taille 10001 et de pas regulier VI
dfin=d0(length(z0));
d0=(1/10009):(dfin/10009):dfin;
d2=d0';
%maintenant x, z, et d sont des vecteurs reguliers.
z11=(a0(1,1).*d0.*d0.*d0.*d0)+(a0(1,2).*d0.*d0.*d0)+(a0(1,3).*d0.*d0)+(a0(1,4).*d0)+(a0(1,5));
v11=(b0(1,1).*d0.*d0.*d0.*d0)+(b0(1,2).*d0.*d0.*d0)+(b0(1,3).*d0.*d0)+(b0(1,4).*d0)+(b0(1,5));
%On calcule au point de donnée la valeur interpolée
z12=(a0(1,1).*d2.*d2.*d2.*d2)+(a0(1,2).*d2.*d2.*d2)+(a0(1,3).*d2.*d2)+(a0(1,4).*d2)+(a0(1,5));
v12=(b0(1,1).*d2.*d2.*d2.*d2)+(b0(1,2).*d2.*d2.*d2)+(b0(1,3).*d2.*d2)+(b0(1,4).*d2)+(b0(1,5));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Mean value for first 1cm of the trajectory
j=1;
for i=1:length(d2(:,1))
    if(d2(i,1)<=1.1)
       v13(j,1)=v12(i,1);
       j=j+1;
    end
end
M13=mean(v13(:,1));
figure(3)
hold on
plot(v0,z0,'.')
plot(v12,z12)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Velocity interpolation 
out_vel=fopen([num2str(exp) '_vinterpZt.txt'],'w');
for i=1:length(v12(:,1))
    fprintf(out_vel,'%f12 %f12 \n', v12(i,1), z12(i,1));
end
fclose(out_vel);
