

	Program VOLCAN

C   Programme de difference finie (1D) , traitant l'equation adimensionalisee:
C
C   Conditions initiales:ouverture de la fissure sur 100 points
C   Conditions au limites:au premier point, l'ouverture est fixee
C   par la surpression de la chambre, au dernier point, la fissure est fermee
C   is: nombre de points de la grille 
C   npt:nombre de pas de temps
C   Dz: pas d'espace
C   Dt: pas de temps
C
C   Pour changer le pas d'espace il faut changer is et les dimensions des 
C    tableaux
C
C    Par rapport a max.for: pression a la base variable 
C
        implicit double precision (a-h,o-z)
        double precision m,l,mu,nu
        parameter (is=10001)
        parameter (npt=9000000)

        common/truc1/b1(10001)
        common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
        common/truc3/av(9999,3)
        common/truc4/b2(9999)
        common/truc5/b3(9999)
        common/truc6/sygedr(10001),nu,h
        common/truc8/verif(9999)


        namelist/geo/h,a
        namelist/init/dP,dlonga,charge
        namelist/phys1/g,m,ROr
        namelist/phys2/ROl,mu,nu


       

C	
C  ****ouverture des fichiers entree et sortie **********************
C   
C

	OPEN (1,file='entrALEX.dat',status='old')
	OPEN (2,file='sortiefro.m',status='old')
        OPEN (3,file='sinvdat.m',status='old')
        OPEN (4,file='sresfront.m',status='old')
        OPEN (7,file='sygedifice.m',status='old')
C        OPEN (8,file='sresflux.m',status='old')
C        OPEN (9,file='sresDV.m',status='old')
        OPEN (10,file='sortieflu.m',status='old')
        OPEN (11,file='sortie.dat',status='old')
        OPEN (12,file='sortiet.m',status='old')
        OPEN (13,file='sortieDV.m',status='old')
        OPEN (14,file='sproffin.m',status='old')
        OPEN (15,file='sortieV.m',status='old')
        OPEN (17,file='srest.m',status='old')
	OPEN (19,file='entr_pos_z.txt',status='old',form='formatted')
	OPEN (20,file='entr_syg.txt',status='old',form='formatted')
	OPEN (21,file='entr_dsyg.txt',status='old',form='formatted')
	OPEN (22,file='entr_d2syg.txt',status='old',form='formatted')
	OPEN (23,file='entr_dz.txt',status='old',form='formatted')
	OPEN (24,file='entr_d2z.txt',status='old',form='formatted')
C
C
C  *************parametres geometrique
C                          initiaux
C                          physiques  ******************************
C 
C  h = profondeur du reservoir          m=
C  a = largeur de la fissure            ROr=densite de lencaissant
C                                       Rol=densite du liquide
C                                       mu=viscosite
C  dP = surpression initiale            nu=
C
C  *************************************************************************
C
 
        
        read(1,geo) 
        read(1,init) 
        read(1,phys1)
        read(1,phys2)

     

C
C***************pas d espace,de temps************        
C           ,position du front au depart:jp

        Dz=dlonga/h 
        Dt=2D-7
        jp=(is-1)/100
        PI=3.141592654
        nbritavsaut=0
        icompt=0
        io=1

        itest1=200000
C    10 sortie par million d'iteration ici
C        it=itest1*Dt*1000000000
C        write(*,*) itest1,it
C        ik=mod(20000000,it)
C        write(*,*) ik 
        itest2=npt/200
        int=npt/50000
c  les trois derniers gerent les sorties

       

C
C *************construction des echelles **********************************
C 
C       T :echelle de temps 
C       bech :echelle de largeur de la fissure
C

        T=(16D0*mu*h*h*m*m)/(dP**3D0*a*a)
        bech=dP*a/m
        fluxech=(dP**5D0*a**4D0)/(16D0*m**4D0*mu*h)
      

C************************************************************************
C      Nombres sans dimensions
C  


C 
C voir cahier 13 octobre 2008....
        R1=(ROl-ROr)*g*h/dP
        R2=charge/dP
        
        ar=m/dP
        write(11,*) 'R1',R1

C*************************************************************************
C a reecrire en fonction de R1 en lisant les fichiers.....          
          call sygcon(is,R1,dP)

C          stop
 

C
C*********************************************************************
C     initialisation
C*********************************************************************
C mise a zero necessaire......

         do 21 j=1,is-2
          b2(j)=0D0
          b3(j)=0D0
          do 23,k=1,3
           av(j,k)=0D0
 23       continue
 21      continue


C*********************************************************************
C    profil initial  : parabolique 
C
C   b1(1) correspond a la surpression dP

        do 11 i=1,jp-1 
          s1=dfloat(jp-i)
          s2=dfloat(jp-1)
          b1(i)=(1D0-sygedr(1))*dsqrt(s1)/dsqrt(s2)
11      continue
        do 12 i=jp,is
          b1(i)=0D0
12      continue     

C*********************************************************************
 

         vol2=volume(jp,ar,Dz,PI)
         f2=flux(PI,ar,0D0)
         vol3=vol2
         f3=f2
         
C**********************************************************************
C    sortie matlab 


        write(3,*)'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(3,*)'itest=',itest1,';'
         write(3,*)'R1=',R1,';'
         write(3,*)'b1=['
         do 16 i=1,1000
           write(3,77) b1(i)
16        continue
77       format(E16.8)
         write(3,*)'];'
         write(3,*)'clmb;'

         write(4,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(4,*) 'itest=',itest2,';'
         write(4,*) 'R1=',R1,';'
         write(4,*) 'imfront=['

C         write(8,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
C         write(8,*) 'itest=',itest2,';'
C         write(8,*) 'R1=',R1,';'
C         write(8,*) 'imflux=['
         
         write(17,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(17,*) 'itest=',itest2,';'
         write(17,*) 'R1=',R1,';'
         write(17,*) 'imtemps=['
         

C         write(9,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
C         write(9,*) 'itest=',itest2,';'
C         write(9,*) 'R1=',R1,';'
C         write(9,*) 'imDV=['
      
         write(2,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(2,*) 'int=',int,';'
         write(2,*) 'R1=',R1,';'
         write(2,*) 'front=['

         write(10,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(10,*) 'int=',int,';'
         write(10,*) 'R1=',R1,';'
         write(10,*) 'flux=['

         write(12,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(12,*) 'int=',int,';'
         write(12,*) 'R1=',R1,';'
         write(12,*) 'temps=['

         write(13,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(13,*) 'int=',int,';'
         write(13,*) 'R1=',R1,';'
         write(13,*) 'DV=['

         write(15,*) 'npt=',npt,';Dz=',Dz,';Dt=',Dt,';'
         write(15,*) 'int=',int,';'
         write(15,*) 'R1=',R1,';'
         write(15,*) 'V=['






C*************************************************************************
C BOUCLE PRINCIPALE
C

       do 14 k=1,npt
C
C Temps qu'il faut pour atteindre ....
C


         


         if ((jp.eq.io*(is-1)/10).and.(icompt.eq.(io-1))) then
         icompt=icompt+1
         io=io+1
         write(11,*) 'A z','=',dfloat(jp)*Dz
         write(11,*) 'Temps: ',(dfloat(k)-1D0)*Dt
         write(11,*) 'Volume=',vol2
         write(11,*) 'Flux=',fluxentree
         endif

C
C  condition d'arret qd arrive a proximite de la surface
C
         if (jp.ge.(is-10)) then
                          write(11,*) 'FIN=1'
                          goto 722
                         endif
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC                           
         if ((jp+2).le.is) then
                            ic=jp+2
                            else
                            ic=is
                            endif
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

         vol1=vol2
         f1=f2
         vol2=vol3
         f2=f3
         call matr(ic,0D0)
         call coninv(ic,0D0)
         call solequa(ic)
             
          do 19 i=2,ic-1
          b1(i)=b3(i-1)
         if ((0D0.gt.b1(i)).and.(ic.le.(jp-1)))  then
          write(11,*) 'fissure fermee'
          goto 722
          endif
 19       continue 

C
C condition permettant de verifier que le critere de courant est
C respecte, si ce n''est pas le cas: changer Dt
C     
         z1=((dfloat(jp)-1D0)*Dz*b1(jp-2)*b1(jp-2)-
     &    (dfloat(jp)-2D0)*Dz*b1(jp-1)*b1(jp-1))
         z2=(b1(jp-2)*b1(jp-2)-b1(jp-1)*b1(jp-1))
         zf=z1/z2 
C         write(*,*) zf
C         write(*,*) ((dfloat(jp)+0.5D0)*Dz)
         if (((dfloat(jp)+0.5D0)*Dz).gt.zf) then
                  b1(jp)=0
                  nbritavsaut=nbritavsaut+1 
                                  else 
                  jp=jp+1
                  if (nbritavsaut.le.2) then
                    write(3,*) jp
                    write(3,*) 'saut trop rapide'
                    stop
                   endif
                  nbritavsaut=0
         endif

C        SORTIE MATLAB DU PROFIL
         
C         ik=k*Dt*1000000000 
         if(mod(k,itest1).eq.0) then
         write(3,*)'nit=',k,';' 
         write(3,*)'tadim=',dfloat(k)*Dt,';'
         write(3,*)'jp=',dfloat(jp)*Dz,';'             
         write(3,*)'bs=['
         do 748 i=1,jp+10
           write(3,77) b1(i)
748        continue
         write(3,*)'];'
         write(3,*) 'clma;'
         endif
      

C        FIN SORTIE

         vol3=volume(jp,ar,Dz,PI)
         f3=flux(PI,ar,0D0)

          
        
           
          DV=(vol3-vol1)/(2D0*Dt)
          fluxentree=f2



C sortie matlab
        
         if(mod(k,itest2).eq.0) then
         write(4,*) dfloat(jp)*Dz
C         write(8,77) fluxentree
         write(17,77) dfloat(k)*Dt
C         write(9,77) DV
         endif
  
         if(mod(k,int).eq.0) then
        write(2,*) dfloat(jp)*Dz
        write(10,77) fluxentree
        write(12,*) dfloat(k)*Dt
        write(13,*) DV
        write(15,*) vol3

         endif

 14     continue  

C FIN BOUCLE PRINCIPALE 

722    write(14,*) 'jp=',dfloat(jp)*Dz,';'
       write(14,*)  'temps=',(dfloat(k)-1D0)*Dt,';'
       write(14,*) 'B=['
       do 767 i=1,is
           write(14,*) b1(i)
767        continue
         write(14,*)'];'
         write(14,*) 'z=flipud(rot90([0:1E-04:1]));'
         write(14,*) 'plot(z,B)'

  
        write(4,*) '];'
C        write(8,*) '];'
C        write(9,*) '];'
        write(17,*) '];'
        write(2,*) '];'
        write(10,*) '];'
        write(12,*) '];'
        write(13,*) '];'
        write(15,*) '];'
 

        write (11,*) 'jp=',dfloat(jp)*Dz,
     &   ';derit=',k-1,';'
        write (11,*) 'tempsfinal=',(dfloat(k)-1D0)*Dt,';'
        write (11,*) 'volume final=',vol3

	STOP
	END



       
C   
C  ************ calcul des effets dus a l edifice**************************
C
C
C     sygedr: contrainte elastique due a l edifice (valeur reduite)
C         {syged(1):contrainte en z=0}
C     dsygedr: derivee de syged (valeur reduite)
C     d2sygedr: derivee seconde de syged (valeur reduite)
C
C       la subroutine sygcon correspond a une charge conique
C   On inclue l''effet de buoyancy...
C
C  ************************************************************************


C
C
C  ************************************************************************

        SUBROUTINE sygcon(n,R1,dP)

C completement modifie on sort l''effet de la densite variable
C  a modifier...

        implicit double precision (a-h,o-z)
        double precision nu
        integer v
        double precision z(10001),syg(10001),dsyg(10001)
        double precision d2syg(10001),ddz(10001),d2z(10001) 
        
        common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
        common/truc6/sygedr(10001),nu,h 
        

 	read(19,*) z
 	read(20,*) syg
	read(21,*) dsyg
	read(22,*) d2syg
  	read(23,*) ddz
        read(24,*) d2z  

      do 222 v=1,n
        z(v)=(h-z(v))/h
        ddz(v)=-ddz(v)
        d2z(v)=-h*d2z(v)    
        syg(v)=syg(v)/dP
        dsyg(v)=dsyg(v)*h/dP
        d2syg(v)=d2syg(v)*h*h/dP
        sygedr(v)=syg(v)+R1*z(v)
        dsygedr(v)=dsyg(v)+R1*ddz(v)
        d2sygedr(v)=d2syg(v)+R1*d2z(v)
 222   continue

        
C          sygedr(i)=R2*(ob+od)
C          dsygedr(i)=-R2*(og)
C          d2sygedr(i)=R2*(-oj)



      

C      SORTIE MATLAB des valeurs adimensionnees 

C       write(7,*)'rc=['
C       do 1655 i=1,n
C       write(7,*) roc(i)
C 1655   continue
C       write(7,*)'];'





       write(7,*)'SYG=['
       do 165 i=1,n
       write(7,*) sygedr(i)
 165   continue          
       write(7,*)'];'




      write(7,*)'d1SYG=['
       do 166 i=1,n
       write(7,*) dsygedr(i)
 166   continue          
       write(7,*)'];'

       write(7,*)'d2SYG=['
       do 168 i=1,n
       write(7,*) d2sygedr(i)
 168   continue          
       write(7,*)'];'


        return
        END

C
C



C
C **********************************************************************
C construction de la matrice[s,1] qui constitue le membre de droite
C
C      b1 : matrice d'entree: profil de largeur de la fissure a t
C      b2 : matrice de sortie: membre de droite
C
C **********************************************************************
C

       SUBROUTINE matr(n,R1)
 
       implicit double precision (a-h,o-z)
       integer v
       common/truc1/b1(10001)
       common/truc4/b2(9999) 
       common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
        
         
       do 200 v=2,n-1
        c1=((dsygedr(v)+R1)/Dz)*(b1(v-1))**3D0
        c2=-2D0*d2sygedr(v)*(b1(v)**3D0)
        c3=((dsygedr(v)+R1)/Dz)*(-(b1(v+1))**3D0)
        c4=-(b1(v-1)**4D0/(Dz*Dz))
        c5=2D0*b1(v)**4D0/(Dz*Dz)
        c6=-(b1(v+1)**4D0/(Dz*Dz))
        b2(v-1)=b1(v)/Dt+c1+c2+c3+c4+c5+c6
 200   continue

       c7=(3D0/Dz)*(dsygedr(2)+R1)*b1(1)*b1(1)-
     &   2D0*(b1(1))**3D0/(Dz*Dz)
       c8=(-3D0/Dz)*(dsygedr(n-1)+R1)*b1(n)*b1(n)-2D0*(b1(n))**3D0
     & /(Dz*Dz)

       b2(1)=b2(1)-b1(1)*c7
       b2(n-2)=b2(n-2)-b1(n)*c8
        
       return
       END


C
C******************************************************************
C      Construction de la matrice a inverser
C      Stockage sous la forme d'une matrice[n-2,3]  
C******************************************************************

       SUBROUTINE coninv(n,R1)

       implicit double precision (a-h,o-z)
       common/truc1/b1(10001)
       common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
       common/truc3/av(9999,3)
           
       do 400 i=2,n-1
       c4=2D0*(b1(i-1))**3D0/(Dz*Dz)
       c5=2D0*(b1(i+1))**3D0/(Dz*Dz)
       c1=(3D0/Dz)*(dsygedr(i)+R1)*b1(i-1)*b1(i-1)-c4
       c2=1D0/Dt-6D0*d2sygedr(i)*b1(i)*b1(i)+(4D0/(Dz*Dz))*(b1(i)**3D0)
       c3=(-3D0/Dz)*(dsygedr(i)+R1)*b1(i+1)*b1(i+1)-c5
   
        av(i-1,1)=c1
        av(i-1,2)=c2
        av(i-1,3)=c3
400    continue

C  les deux affectations suivantes sont pipo.............
        av(1,1)=0D0
        av(n-2,3)=0D0

        return
        END

C
C************************************************************************
C  Construction du profil a l'etape suivante
C
C************************************************************************

       SUBROUTINE solequa(n1)
C cette routine utilise deux routines: bandec et banbks trouvees dans
C numerical recipies
 
       implicit double precision (a-h,o-z)
       common/truc4/b2(9999)
       common/truc5/b3(9999)
       common/truc3/atv(9999,3)
       common/ttruc1/at(9999,3),a1(9999,1),in2(9999)
       common/ttruc2/res(9999)
       common/truc8/verif(9999)
     
       ie=n1-2
C       write(*,*) ie
       
       do 500 k=1,ie
        res(k)=b2(k)
        do 501 i=1,3
         at(k,i)=atv(k,i)
501     continue
500    continue 
  
       call bandec(ie,1,1,d1)
       call banbks(ie,1,1)
 
        do 502 k=1,n1-2
        b3(k)=res(k)
 502   continue
        
        do 505 j=1,2
        call verification(n1)
           

        do 503 k=1,ie
         res(k)=verif(k)
 503    continue
       
        call banbks(ie,1,1)
        
        do 504 k=1,n1-2
         b3(k)=b3(k)-res(k)
 504    continue
      
 505    continue
     
C       call verification(n1)       
          
       return 
       END
  
       SUBROUTINE bandec(n,m1,m2,d)

       
       integer n
       integer m1,m2,indx
       double precision d,TINY,a,al
       parameter (TINY=1.D-20)
       integer i,j,k,l,mm
       double precision dum
       common /ttruc1/a(9999,3),al(9999,1),indx(9999)

       mm=m1+m2+1
       l=m1
       do 113 i=1,m1
        do 111 j=m1+2-i,mm
         a(i,j-l)=a(i,j)
 111    continue
        l=l-1
        do 112 j=mm-l,mm
         a(i,j)=0
 112    continue
 113   continue
       d=1
       l=m1
       do 118 k=1,n
        dum=a(k,1)
        i=k
        if(l.lt.n)l=l+1
        do 114 j=k+1,l
         if(abs(a(j,1)).gt.abs(dum))then
                dum=a(j,1)
                i=j
         endif
 114    continue
        indx(k)=i
        if(dum.eq.0.) a(k,1)=TINY
        if(i.ne.k)then
            d=-d
            do 115 j=1,mm
             dum=a(k,j)
             a(k,j)=a(i,j)
             a(i,j)=dum
 115        continue
        endif
        do 117 i=k+1,l
         dum=a(i,1)/a(k,1)
         al(k,i-k)=dum
         do 116 j=2,mm
          a(i,j-1)=a(i,j)-dum*a(k,j)
 116     continue
         a(i,mm)=0    
 117    continue            
 118   continue

       return
       END       

       SUBROUTINE banbks(n,m1,m2)
         
      
        integer m1,m2,n,indx
        integer i,k,l,mm
        double precision dum,a,al,b
        common /ttruc1/a(9999,3),al(9999,1),indx(9999)
        common /ttruc2/b(9999)

        mm=m1+m2+1
        l=m1
        do 112 k=1,n
         i=indx(k)
         if(i.ne.k)then
              dum=b(k)
              b(k)=b(i)
              b(i)=dum
         endif
         if(l.lt.n)l=l+1
         do 111 i=k+1,l
          b(i)=b(i)-al(k,i-k)*b(k)
 111     continue
 112    continue
        l=1
        do 114 i=n,1,-1
         dum=b(i)
         do 113 k=2,l
          dum=dum-a(i,k)*b(k+i-1)
 113     continue
         b(i)=dum/a(i,1)
         if(l.lt.mm)l=l+1
 114    continue

        return
        END


C
C*************************************************************************
C   Verification de l'inversion, si inversion OK: verif doit contenir 
C    l'identite
C
C*************************************************************************
C
  
        SUBROUTINE verification(n)
        
        implicit double precision (a-h,o-z)
        common/truc3/av(9999,3)
        common/truc4/b2(9999)
        common/truc5/b3(9999)
        common/truc8/verif(9999)
     
        
         verif(1)=av(1,2)*b3(1)+av(1,3)*b3(2)-b2(1)
         c=av(n-2,2)*b3(n-2)
         verif(n-2)=av(n-2,1)*b3(n-3)+c-b2(n-2)


          do 32 i=2,n-3
           v1=av(i,1)*b3(i-1)
           v2=b3(i)*av(i,2)
           v3=av(i,3)*b3(i+1)
           verif(i)=v1+v2+v3-b2(i)
 32       continue
 31      continue
        
C         write(*,*) 'Verif :'
C         do 177 j=1,n-2
C          write(*,144) verif(j)   
C 177     continue
C 144     format(D12.5)   
    
         return
         END

C
C**************************************************************************
C Verification de la conservation de la masse
C
C**************************************************************************
C

         FUNCTION volume(jp,ar,Dz,PI)

         implicit double precision (a-h,o-z)
         common/truc1/b1(10001)
        
         vol=0D0
         do 66 i=1,jp-1
         bmoy=(b1(i)+b1(i+1))/2D0
         vol=vol+ar*PI*bmoy*Dz
 66      continue
         volume=vol

         return
         END        
C**************************************************************************  
        
         FUNCTION flux(PI,ar,R1)
C calcul sur trois points, avec db1(1)**4/dz


         implicit double precision (a-h,o-z)
         common/truc1/b1(10001)
         common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
         va=b1(1)**3D0
         vb=4D0*b1(2)**4D0-3D0*b1(1)**4D0-b1(3)**4D0          
         flux=PI*ar*(va*(-R1-dsygedr(1))*4D0-vb/(2D0*Dz))
         return
         END
        
C         FUNCTION flux2(PI,ar,R1)
C calcul en extrapolant q1.5 et q2.5
C  ATTENTION CETTE ROUTINE UTILISE R2 NON DEFINI

C         implicit double precision (a-h,o-z)
C         common/truc1/b1(10001)
C         common/truc2/dsygedr(10001),d2sygedr(10001),Dt,Dz
C        
C         va1=(b1(1)**3D0+b1(2)**3D0)/2D0
C         va2=(b1(2)**3D0+b1(3)**3D0)/2D0
C         vc1=(dsygedr(1)+dsygedr(2))/2D0
C         vc2=(dsygedr(2)+dsygedr(3))/2D0
C         vb1=b1(2)-b1(1)        
C         vb2=b1(3)-b1(2)        

C         ff1=PI*ar*va1*(-R1*4D0-vc1*R2-vb1*4D0/Dz)
C         ff2=PI*ar*va2*(-R1*4D0-vc2*R2-vb2*4D0/Dz)
C         flux2=1.5D0*ff1-0.5D0*ff2
                  
C         return
C         END
