clear all;
close all;


%Files required inside the current directory :
% myinterpval.m myinterpval1D.m mynormalize.m myresample.m 
% comsol files : directions1_HX_2D.txt and stressfield_rigidload_HX_2D.txt
% experimental path data.txt

% For each experiment given the hole, choose Xt
% take the right files directions1_HX_2D.txt ant stressfield_rigidload_HX_2D.txt
% take the right file EXPXX_trajectory_velocity.txt
%modify Xt
%modify Xs
%modify Zs
%modify Loadapplied: applied load (g)
%modify the crack length L (m)
%eventually modify grids limits when needed
%In this example, everything corresponds to EXP61

%Parameters
Xt=-4*0.01; %location of hole4  (m)
%Xt=-8*0.01 % location of hole5  (m)
%Xt=0*0.01 % location of hole3  (m)
%Xt=4*0.01 % location of hole2  (m)
%Xt=8*0.01 % location of hole1  (m)
%Xt=6*0.01 % location of hole8  (m)
%Xt=2*0.01 % location of hole9  (m)
%Xt=-2*0.01 % location of hole10  (m)
%Xt=-6*0.01 % location of hole11 (m)


% Xs=Xstart Zs=Zstart  (m)
Xs=9.5*0.01;
Zs=7.9*0.01;

%(applied load g)
loadapplied=229.6;
%load applied en Pa
loadPa=loadapplied*0.001*9.81/(0.06*0.14);
L=3.8*0.01;  %crack length m


format long e
% f=facteur de multiplication =1 normalement ; =1000 en analogique (cela convertira tout en mm pour la grille)
f=1000;
%% paramêtres variables
%//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
pdg=0.0005; % pas de distance pour la grille (m)
pdq=0.005; % pas de distance pour representation des sigma

pdg=pdg*f;
pdq=pdq*f;

pos_ini_r=Xt+(Xs-0.084) ; % position initial dyke en r (m) (0-10000)
%position du trou/au centre de la cuve (-4cm pour trou le trou 4) + (xs-8.4)cm � exprimer en m
pos_ini_z=Zs ; % position initail dyke en z (m) ici profondeur (0-10000)
%pos_ini_z vaut zs en exprim� en m

pos_ini_r=pos_ini_r*f;
pos_ini_z=pos_ini_z*f;


WZ=501;    %taille de la fenetre de lissage de savitzky-gollay (!!!impaire!!!)
rhomag=0; %masse volumique magma (kg.m⁻³)
rhoenc=1000; %masse volumique encaissant (kg.m⁻³)
dP=100; % Supression à la base dans la chambre
g=9.81 ; 
charge=100; %masse appliquee en g pour le calcul de contrainte dans le fichier COMSOL


%% data loading

%load directions1_H04_fine.txt % importation des données d'orientation de sigma 1
%load stressfield_rigidload_H04_fine.txt % importation des données des valeurs des contraintes

%%%% 2D stress field
load directions1_H04_2D.txt % importation des données d'orientation de sigma 1
load stressfield_rigidload_H04_2D.txt % importation des données des valeurs des contraintes

%  directions sigmas 1
%R=directions1_H04_fine(:,1)*f; % positions r
%Z=directions1_H04_fine(:,3)*f; % positions z
%dir_r=directions1_H04_fine(:,4); % directions sigmas 1 selon r
%dir_z=directions1_H04_fine(:,6); % directions sigmas 1 selon z

R=directions1_H04_2D(:,1)*f; % positions r
Z=directions1_H04_2D(:,2)*f; % positions z
dir_r=directions1_H04_2D(:,3); % directions sigmas 1 selon r
dir_z=directions1_H04_2D(:,4); % directions sigmas 1 selon z


%on enl�ve les valeurs positives de Z
a1=find(Z<=0);
R=R(a1);
Z=Z(a1);
dir_r=dir_r(a1);
dir_z=dir_z(a1);


% données intensitées sigmas 1 2 3
%val_R=stressfield_rigidload_H04_fine(:,1)*f; % positions r
%val_Z=stressfield_rigidload_H04_fine(:,3)*f; % positions z
%val_sig_x=-stressfield_rigidload_H04_fine(:,4)*loadapplied/charge; % valeurs sigmas 3
%val_sig_z=-stressfield_rigidload_H04_fine(:,5)*loadapplied/charge;
%val_sig_xz=-stressfield_rigidload_H04_fine(:,7)*loadapplied/charge;


val_R=stressfield_rigidload_H04_2D(:,1)*f; % positions r
val_Z=stressfield_rigidload_H04_2D(:,2)*f; % positions z
val_sig_x=-stressfield_rigidload_H04_2D(:,3)*loadPa; % valeurs sigmas 3
val_sig_z=-stressfield_rigidload_H04_2D(:,4)*loadPa;
val_sig_xz=-stressfield_rigidload_H04_2D(:,5)*loadPa;

%on enl�ve les valeurs positives de Z
a2=find(val_Z<=0);
val_R=val_R(a2);
val_Z=val_Z(a2);
val_sig_x=val_sig_x(a2);
val_sig_z=val_sig_z(a2);
val_sig_xz=val_sig_xz(a2);

%on enl�ve les valeurs abh�rantes
a3=find((abs(val_sig_x)<=100*loadPa)&(abs(val_sig_z)<=100*loadPa)&(abs(val_sig_xz)<=100*loadPa));
R=R(a3);
Z=Z(a3);
dir_r=dir_r(a3);
dir_z=dir_z(a3);
val_R=val_R(a3);
val_Z=val_Z(a3);
val_sig_x=val_sig_x(a3);
val_sig_z=val_sig_z(a3);
val_sig_xz=val_sig_xz(a3);


%% Mise en place grille interpolation
xmin=-0.2;     % taille de la grille d'interpolation en m
xmax=0;
zmax=0;
zmin=-0.15;
xmin=xmin*f;
xmax=xmax*f;
zmin=zmin*f;
zmax=zmax*f;


Rbis=xmin:pdg:xmax; % limitation de la zone d'interpolation en r (correspond à de 0 a 14.5 cm)
Zbis=-(-zmax:pdg:-zmin); % limitation de la zone d'interpolation en z (correspond à un hauteur max de 6 cm et une profondeur max de 10 cm)
[Rr,Zz]=meshgrid(Rbis,Zbis); % mise en place de la grille d'interpolation
inter_dir_r=griddata(R,Z,dir_r,Rr,Zz,'cubic'); % interpolation au voisin le plus proche de la direction de sigma1 selon r
inter_dir_z=griddata(R,Z,dir_z,Rr,Zz,'cubic'); % interpolation au voisin le plus proche de la direction de sigma1 selon z
inter_sigx=griddata(val_R,val_Z,val_sig_x,Rr,Zz,'cubic'); % interpolation sigma 3
inter_sigz=griddata(val_R,val_Z,val_sig_z,Rr,Zz,'cubic'); % interpolation sigma 3
inter_sigxz=griddata(val_R,val_Z,val_sig_xz,Rr,Zz,'cubic'); % interpolation sigma 3
Rterc=xmin:pdq:xmax; %limitation zone interpolation pour quiver en r
Zterc=-(-zmax:pdq:-zmin); %limitation zone interpolation pour quiver en z
[Rrr,Zzz]=meshgrid(Rterc,Zterc); %Grille interpolation pour quiver
inter_dir_R_qui=griddata(R,Z,dir_r,Rrr,Zzz,'cubic'); %interpolation sig1 quiver
inter_dir_Z_qui=griddata(R,Z,dir_z,Rrr,Zzz,'cubic'); %interpolation sig1 quiver
%% normalisation direction

[inter_dir_r_norm,inter_dir_z_norm]=mynormalize(inter_dir_r,inter_dir_z);
[inter_dir_R_qui_norm,inter_dir_Z_qui_norm]=mynormalize(inter_dir_R_qui,inter_dir_Z_qui);
%% remise des direction dans le bon sens

T1=size(inter_dir_z_norm);
T2=size(inter_dir_Z_qui_norm);


for i=1:1:T1(1)
   for j=1:1:T1(2)
       if inter_dir_z_norm(i,j)<0
           inter_dir_z_norm(i,j)=-inter_dir_z_norm(i,j);
           inter_dir_r_norm(i,j)=-inter_dir_r_norm(i,j);
       end
   end
end



 for i=1:1:T2(1)
    for j=1:1:T2(2)
        if inter_dir_Z_qui_norm(i,j)<0
            inter_dir_Z_qui_norm(i,j)=-inter_dir_Z_qui_norm(i,j);
            inter_dir_R_qui_norm(i,j)=-inter_dir_R_qui_norm(i,j);
        end
    end
 end

 


%% Read experiemental data
load EXP61_trajectory_velocity.txt
% lit les positions donn�es en cm, passage au m
xdel=data(:,2);
%recalage par rapport � xs 
xdel=xdel+ones(size(xdel))*((pos_ini_r/f)-xdel(1));
xdel=xdel*f;
zdel=data(:,3);

%choix de recaler par rapport � la surface
 zdel=zdel-ones(size(zdel))*zdel(end);
 zdel=zdel*f;
 
 if -zdel(1)>pos_ini_z 
     disp('trajectoire coup�e en bas')
     debut=min(find(-zdel<=pos_ini_z));
     xdel=xdel(debut:end);
     xdel=xdel+ones(size(xdel))*((pos_ini_r)-xdel(1));
     zdel=zdel(debut:end);
 else
     xdel=[xdel(1);xdel];
     zdel=[-pos_ini_z;zdel];     
 end
 
 %pos_ini_z=-zdel(1);
 


% je convertit mon z en une profondeur
zdel=-zdel;




%zg et xg defini sur la grille 
zg(1)=(zdel(1)+zmax)/pdg;
ndpdd=length(xdel);
xg(1)=(xdel(1)-xmin)/pdg;
dg(1)=0;

%%%% definition de limites pour la trajectoire (d�finie comme limite de la grille choisie)
xlimsup=(xmax-xmin)/pdg;
xliminf=1;
zliminf=1;
zlimsup=(zmax-zmin)/pdg;




for i=2:ndpdd  %iteration trajectoire
    xg(i)=(xdel(i)-xmin)/pdg;
    zg(i)=(zdel(i)+zmax)/pdg;
    dg(i)=dg(i-1)+sqrt(((xg(i)-xg(i-1))*(xg(i)-xg(i-1)))+((zg(i)-zg(i-1))*(zg(i)-zg(i-1))));
   
    if  xg(i)>xlimsup-1
        break
    end
    if  xg(i)<xliminf+1
        break
    end
    if  zg(i)<zliminf+1
        break
    end
    if  zg(i)>zlimsup-1
        break
    end
    
end

% si on finit la trajectoire avant la fin: on reduit ndpdd
ndpdd=i;


%on repasse aux vraies valeurs (en m)

x=(xg*pdg+xmin)/f;
z=(zg*pdg-zmax)/f;
d=dg*pdg/f;

%xtrue, ztrue, dtrue contiennent les vraies valeurs en m
xtrue=x;
ztrue=z;
dtrue=d;

a=polyfit(d,z,6);
b=polyfit(d,x,6);


%%nouveau vecteur de taille 10001 et de pas regulier VI
dfin=d(ndpdd);
%d=(1/10009):(dfin/10009):dfin;
d=0:(dfin/10000):dfin;

%maintenant x, z, et d sont des vecteurs reguliers.

z=(a(1,1).*d.*d.*d.*d.*d.*d)+(a(1,2).*d.*d.*d.*d.*d)+(a(1,3).*d.*d.*d.*d)+(a(1,4).*d.*d.*d)+(a(1,5).*d.*d)+(a(1,6).*d)+(a(1,7));
x=(b(1,1).*d.*d.*d.*d.*d.*d)+(b(1,2).*d.*d.*d.*d.*d)+(b(1,3).*d.*d.*d.*d)+(b(1,4).*d.*d.*d)+(b(1,5).*d.*d)+(b(1,6).*d)+(b(1,7));
diffx=(6*b(1,1).*d.*d.*d.*d.*d)+(5*b(1,2).*d.*d.*d.*d)+(4*b(1,3).*d.*d.*d)+(3*b(1,4).*d.*d)+(2*b(1,5).*d)+(b(1,6));
diffz=(6*a(1,1).*d.*d.*d.*d.*d)+(5*a(1,2).*d.*d.*d.*d)+(4*a(1,3).*d.*d.*d)+(3*a(1,4).*d.*d)+(2*a(1,5).*d)+(a(1,6));
diff2z=(30*a(1,1).*d.*d.*d.*d)+(20*a(1,2).*d.*d.*d)+(12*a(1,3).*d.*d)+(6*a(1,4).*d)+(2*a(1,5));

%calcul de l'angle � partir de la valeur interpol�e de la trajectoire
theta=atan(diffx./diffz);


for i=1:ndpdd %calcule sigma 3 
    o=ones(size(z));
    ind=find(abs(z-ztrue(i)*o)==min(abs(z-ztrue(i)*o)));
    sx=myinterpval(inter_sigx,xg(i),zg(i));
    sz=myinterpval(inter_sigz,xg(i),zg(i));
    sxz=myinterpval(inter_sigxz,xg(i),zg(i));
    sxzref(i)=sxz;
    pos_sig3(i)=sx*cos(theta(ind))*cos(theta(ind))+sz*sin(theta(ind))*sin(theta(ind))+sxz*sin(2*theta(ind)); 
end


%% polyfit
% ici choix de l'ordre d'interpolation....

%%interp  de 11
%c=polyfit(dtrue(1:end-2),pos_sig3(1:end-2),11)
%sig3=(c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,2).*d.*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,3).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,4).*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,5).*d.*d.*d.*d.*d.*d.*d)+(c(1,6).*d.*d.*d.*d.*d.*d)+(c(1,7).*d.*d.*d.*d.*d)+(c(1,8).*d.*d.*d.*d)+(c(1,9).*d.*d.*d)+(c(1,10).*d.*d)+(c(1,11).*d)+(c(1,12));
%diff_sig3=(11*c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d.*d)+(10*c(1,2).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(9*c(1,3).*d.*d.*d.*d.*d.*d.*d.*d)+(8*c(1,4).*d.*d.*d.*d.*d.*d.*d)+(7*c(1,5).*d.*d.*d.*d.*d.*d)+(6*c(1,6).*d.*d.*d.*d.*d)+(5*c(1,7).*d.*d.*d.*d)+(4*c(1,8).*d.*d.*d)+(3*c(1,9).*d.*d)+(2*c(1,10).*d)+(c(1,11));
%diff2_sig3=(110*c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(90*c(1,2).*d.*d.*d.*d.*d.*d.*d.*d)+(72*c(1,3).*d.*d.*d.*d.*d.*d.*d)+(56*c(1,4).*d.*d.*d.*d.*d.*d)+(42*c(1,5).*d.*d.*d.*d.*d)+(30*c(1,6).*d.*d.*d.*d)+(20*c(1,7).*d.*d.*d)+(12*c(1,8).*d.*d)+(6*c(1,9).*d)+(2*c(1,10));


%%interp  de 10
%c=polyfit(dtrue(1:end-2),pos_sig3(1:end-2),10)
%sig3=(c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,2).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,3).*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,4).*d.*d.*d.*d.*d.*d.*d)+(c(1,5).*d.*d.*d.*d.*d.*d)+(c(1,6).*d.*d.*d.*d.*d)+(c(1,7).*d.*d.*d.*d)+(c(1,8).*d.*d.*d)+(c(1,9).*d.*d)+(c(1,10).*d)+(c(1,11));
%diff_sig3=(10*c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(9*c(1,2).*d.*d.*d.*d.*d.*d.*d.*d)+(8*c(1,3).*d.*d.*d.*d.*d.*d.*d)+(7*c(1,4).*d.*d.*d.*d.*d.*d)+(6*c(1,5).*d.*d.*d.*d.*d)+(5*c(1,6).*d.*d.*d.*d)+(4*c(1,7).*d.*d.*d)+(3*c(1,8).*d.*d)+(2*c(1,9).*d)+(c(1,10));
%diff2_sig3=(90*c(1,1).*d.*d.*d.*d.*d.*d.*d.*d)+(72*c(1,2).*d.*d.*d.*d.*d.*d.*d)+(56*c(1,3).*d.*d.*d.*d.*d.*d)+(42*c(1,4).*d.*d.*d.*d.*d)+(30*c(1,5).*d.*d.*d.*d)+(20*c(1,6).*d.*d.*d)+(12*c(1,7).*d.*d)+(6*c(1,8).*d)+(2*c(1,9));


% %%interp  de 9
% c=polyfit(dtrue(1:end-2),pos_sig3(1:end-2),9);
% sig3=(c(1,1).*d.*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,2).*d.*d.*d.*d.*d.*d.*d.*d)+(c(1,3).*d.*d.*d.*d.*d.*d.*d)+(c(1,4).*d.*d.*d.*d.*d.*d)+(c(1,5).*d.*d.*d.*d.*d)+(c(1,6).*d.*d.*d.*d)+(c(1,7).*d.*d.*d)+(c(1,8).*d.*d)+(c(1,9).*d)+(c(1,10));
% diff_sig3=(9*c(1,1).*d.*d.*d.*d.*d.*d.*d.*d)+(8*c(1,2).*d.*d.*d.*d.*d.*d.*d)+(7*c(1,3).*d.*d.*d.*d.*d.*d)+(6*c(1,4).*d.*d.*d.*d.*d)+(5*c(1,5).*d.*d.*d.*d)+(4*c(1,6).*d.*d.*d)+(3*c(1,7).*d.*d)+(2*c(1,8).*d)+(c(1,9));
% diff2_sig3=(72*c(1,1).*d.*d.*d.*d.*d.*d.*d)+(56*c(1,2).*d.*d.*d.*d.*d.*d)+(42*c(1,3).*d.*d.*d.*d.*d)+(30*c(1,4).*d.*d.*d.*d)+(20*c(1,5).*d.*d.*d)+(12*c(1,6).*d.*d)+(6*c(1,7).*d)+(2*c(1,8));

%%interp  de 7
%c=polyfit(dtrue(1:end-2),pos_sig3(1:end-2),7);
%sig3=(c(1,1).*d.*d.*d.*d.*d.*d.*d)+(c(1,2).*d.*d.*d.*d.*d.*d)+(c(1,3).*d.*d.*d.*d.*d)+(c(1,4).*d.*d.*d.*d)+(c(1,5).*d.*d.*d)+(c(1,6).*d.*d)+(c(1,7).*d)+(c(1,8));
%diff_sig3=(7*c(1,1).*d.*d.*d.*d.*d.*d)+(6*c(1,2).*d.*d.*d.*d.*d)+(5*c(1,3).*d.*d.*d.*d)+(4*c(1,4).*d.*d.*d)+(3*c(1,5).*d.*d)+(2*c(1,6).*d)+(c(1,7));
%diff2_sig3=(42*c(1,1).*d.*d.*d.*d.*d)+(30*c(1,2).*d.*d.*d.*d)+(20*c(1,3).*d.*d.*d)+(12*c(1,4).*d.*d)+(6*c(1,5).*d)+(2*c(1,6));

%%interp  de 6
%c=polyfit(dtrue(1:end-2),pos_sig3(1:end-2),6)
%sig3=(c(1,1).*d.*d.*d.*d.*d.*d)+(c(1,2).*d.*d.*d.*d.*d)+(c(1,3).*d.*d.*d.*d)+(c(1,4).*d.*d.*d)+(c(1,5).*d.*d)+(c(1,6).*d)+(c(1,7));
%diff_sig3=(6*c(1,1).*d.*d.*d.*d.*d)+(5*c(1,2).*d.*d.*d.*d)+(4*c(1,3).*d.*d.*d)+(3*c(1,4).*d.*d)+(2*c(1,5).*d)+(c(1,6));
%diff2_sig3=(30*c(1,1).*d.*d.*d.*d)+(20*c(1,2).*d.*d.*d)+(12*c(1,3).*d.*d)+(6*c(1,4).*d)+(2*c(1,5));


%Rational
dtrue2=dtrue(1:end-15)';
pos_sig3_2=pos_sig3(1:end-15)';
option=fitoptions('Method','NonlinearLeastSquares','Algorithm','Levenberg-Marquardt','MaxFunEvals',5000,'MaxIter',5000,'TolFun', 1e-8);
[f1,gof1,output1]=fit(dtrue2,pos_sig3_2,'rat44',option); %f1 c'est l'expression analytique de type fourier de degre 7
sig3=zeros(1,length(d));
for i=1:length(d)
    sig3(1,i)=f1(d(i));
end

a=  f1.p1.*d.*d.*d.*d + f1.p2.*d.*d.*d + f1.p3.*d.*d + f1.p4.*d + f1.p5;
da= 4*f1.p1.*d.*d.*d + 3*f1.p2.*d.*d + 2*f1.p3.*d + f1.p4;
dda=12*f1.p1.*d.*d + 6*f1.p2.*d + 2*f1.p3;

b=d.*d.*d.*d + f1.q1.*d.*d.*d + f1.q2.*d.*d + f1.q3.*d + f1.q4;
db=4*d.*d.*d + 3*f1.q1.*d.*d + 2*f1.q2.*d + f1.q3;
ddb=12*d.*d + 6*f1.q1.*d + 2*f1.q2;

diff_sig3= (da.*b - a.*db)./(b.*b);
diff2_sig3=((dda.*b -a.*ddb).*b.*b - (da.*b - a.*db).*2.*db.*b)./(b.*b.*b.*b);

figure(2020)
plot(d,sig3,'b','LineWidth',2)
hold on
plot(dtrue,pos_sig3,'.c','MarkerSize',6)

figure(2021)
plot(d,diff_sig3,'b','LineWidth',2)
hold on
ylim([-2e4 5e3])

figure(2022)
plot(d,diff2_sig3,'b','LineWidth',2)


%fourier
%~ dtrue3=dtrue(1:end-15)';
%~ pos_sig3_3=pos_sig3(1:end-15)';
%~ option=fitoptions('Method','NonlinearLeastSquares','Algorithm','Levenberg-Marquardt','MaxFunEvals',5000,'MaxIter',5000,'TolFun', 1e-8);
%~ [f3,gof3,output3]=fit(dtrue3,pos_sig3_3,'fourier7',option); %f1 c'est l'expression analytique de type fourier de degre 7
%~ sig3_3=zeros(1,length(d));
%~ for i=1:length(d)
    %~ sig3_3(1,i)=f3(d(i));
%~ end

%~ diff_sig3_3  = - f3.w.*f3.a1.*sin(d.*f3.w) + f3.w.*f3.b1.*cos(d.*f3.w) - 2*f3.w.*f3.a2.*sin(2*d.*f3.w) + 2*f3.w.*f3.b2.*cos(2*d.*f3.w) - 3*f3.w.*f3.a3.*sin(3*d.*f3.w) + 3*f3.w.*f3.b3.*cos(3*d.*f3.w) - 4*f3.w.*f3.a4.*sin(4*d.*f3.w) + 4*f3.w.*f3.b4.*cos(4*d.*f3.w) - 5*f3.w.*f3.a5.*sin(5*d.*f3.w) + 5*f3.w.*f3.b5.*cos(5*d.*f3.w) - 6*f3.w.*f3.a6.*sin(6*d.*f3.w) + 6*f3.w.*f3.b6.*cos(6*d.*f3.w) - 7*f3.w.*f3.a7.*sin(7*d.*f3.w) + 7*f3.w.*f3.b7.*cos(7*d.*f3.w);
%~ diff2_sig3_3 = - (f3.w).*(f3.w).*f3.a1.*cos(d.*f3.w) - (f3.w).*(f3.w).*f3.b1.*sin(d.*f3.w) - 4*(f3.w).*(f3.w).*f3.a2.*cos(2*d.*f3.w) - 4*(f3.w).*(f3.w).*f3.b2.*sin(2*d.*f3.w) - 9*(f3.w).*(f3.w).*f3.a3.*cos(3*d.*f3.w) - 9*(f3.w).*(f3.w).*f3.b3.*sin(3*d.*f3.w) - 16*(f3.w).*(f3.w).*f3.a4.*cos(4*d.*f3.w) - 16*(f3.w).*(f3.w).*f3.b4.*sin(4*d.*f3.w) - 25*(f3.w).*(f3.w).*f3.a5.*cos(5*d.*f3.w) - 25*(f3.w).*(f3.w).*f3.b5.*sin(5*d.*f3.w) - 36*(f3.w).*(f3.w).*f3.a6.*cos(6*d.*f3.w) - 36*(f3.w).*(f3.w).*f3.b6.*sin(6*d.*f3.w) - 49*(f3.w).*(f3.w).*f3.a7.*cos(7*d.*f3.w) - 49*(f3.w).*(f3.w).*f3.b7.*sin(7*d.*f3.w);

%~ figure(2030)
%~ plot(d,sig3_3,'b','LineWidth',2)
%~ hold on
%~ plot(dtrue,pos_sig3,'.c','MarkerSize',6)

%~ figure(2031)
%~ plot(d,diff_sig3_3,'b','LineWidth',2)
%~ hold on
%~ ylim([-2e4 5e3])

%~ figure(2032)
%~ plot(d,diff2_sig3_3,'b','LineWidth',2)





sig3plo=sig3;
%sig3plo valeur non corrig�e
sig3=sig3-sig3(1);
%% attention je fais cela pour avoir une contrainte nulle en bas de dyke (sig3)
%% mais du coup la valeur de sigma3 ne veut pas dire grand chose.....
diff_sig3=diff_sig3;
diff2_sig3=diff2_sig3;

%% sortie des données pour lancer le calcul dynamique

hb=z(1,1);
VAL_PROPAG_h=hb;
VAL_PROPAG_dlonga=mean(diff(d));
VAL_PROPAG_h=double(VAL_PROPAG_h);
VAL_PROPAG_dlonga=double(VAL_PROPAG_dlonga);

save('entr_pos_z.txt','z','-ascii','-double')
save('entr_pos_x.txt','x','-ascii','-double')
save('entr_syg.txt','sig3','-ascii','-double')
save('entr_dsyg.txt','diff_sig3','-ascii','-double')
save('entr_d2syg.txt','diff2_sig3','-ascii','-double')
save('entr_dz.txt','diffz','-ascii','-double')
save('entr_d2z.txt','diff2z','-ascii','-double')
save('entr_val_entr.txt','VAL_PROPAG_dlonga','VAL_PROPAG_h','-ascii','-double')


%% sortie des données pour lancer le calcul dynamique de r�f�rence (vertical et sans champ de contrainte...)
zref=fliplr(0:(hb/10000):hb);
VAL_ref_dlonga=-mean(diff(zref));
VAL_ref_dlonga=double(VAL_ref_dlonga);

xref=x(1)*ones(size(x));
diffzref=-1*ones(size(x));
diff2zref=zeros(size(x));
sig3ref=zeros(size(x));
diff_sig3ref=zeros(size(x));
diff2_sig3ref=zeros(size(x));

% save('entrRef_pos_z.txt','zref','-ascii','-double')
% save('entrRef_pos_x.txt','xref','-ascii','-double')
save('entrRef_pos_z.txt','z','-ascii','-double')
save('entrRef_pos_x.txt','x','-ascii','-double')
save('entrRef_syg.txt','sig3ref','-ascii','-double')
save('entrRef_dsyg.txt','diff_sig3ref','-ascii','-double')
save('entrRef_d2syg.txt','diff2_sig3ref','-ascii','-double')
% save('entrRef_dz.txt','diffzref','-ascii','-double')
% save('entrRef_d2z.txt','diff2zref','-ascii','-double')
save('entrRef_dz.txt','diffz','-ascii','-double')
save('entrRef_d2z.txt','diff2z','-ascii','-double')
save('entrRef_val_entr.txt','VAL_ref_dlonga','VAL_PROPAG_h','-ascii','-double')


%% test des conditions de sortie

prof=z(1,1)-z;
test=dP+((rhoenc-rhomag)*g.*prof)-sig3 ;
%%%test2=dP+h*g*rhoenc-rhomag*g*prof;
%%test3=h*g*rhoenc-rhoenc*g*prof+sig3;
cdt_stp=zeros(1,length(test));

figure(1001)
%%plot(d,test3,'b')
 hold on
%% plot(d,test2,'r')
 plot(d,test,'g')
 plot(d,cdt_stp,'--k')
 title('verification condition de sortie')
   xlabel('x(m)')
   ylabel('contrainte (Pa)')
%%  axis([0 d(length(d)) -20 2000])
  hold off
    
figure(1010)
 hold on
plot(zmax/f-z,test)
 hold off

%%buoyancy
%zbas contient la profondeur de la base du crack definie avec la trajectoire et la longueur du crack...
nbpoint=round(L/(mean(diff(d))))+1;
s=length(z); 
if (s > nbpoint) 
 for i=1:nbpoint
 zbas(i)=z(1)+L*(double(nbpoint-i))/double(nbpoint-1);
 end
 for i=nbpoint+1:s
 zbas(i)=z(i-nbpoint+1);
 end
else
 for i=1:s
 zbas(i)=z(1)+L*(double(nbpoint-i))/double(nbpoint-1);
 end
end

  
figure(1004)
%buoyancy
 hold on
 plot((rhoenc-rhomag)*g*prof,-z*100)
 plot((rhoenc-rhomag)*g*(zbas-z)/4,-z*100,'r')
 hold off
 xlabel('Buoyancy')
 ylabel('z(cm)')
 
buoy=(rhoenc-rhomag)*g*(zbas-z)/4;
sort=[flipud(rot90(-z)),flipud(rot90(buoy)),flipud(rot90(sig3plo))];
%sortie de z (profondeur du tip), Pression de buoyancy du crack (Pa),
%sigman interpol�e (Pa)
save('sortieAnalogique1.txt','sort','-ascii','-double')
sort2=[flipud(rot90(-ztrue)),flipud(rot90(pos_sig3))];
%sortie de z (profondeur du tip), 
%sigman non interpol�e (Pa)
save('sortieAnalogique2.txt','sort2','-ascii','-double')
  



%Trajectoire sur la valeur de sigmaxz
figure(1002)
hold on
 b=quiver(Rrr,Zzz,inter_dir_R_qui_norm,inter_dir_Z_qui_norm,'k');
   set(b,'showarrowhead','off')
   set(b,'autoscalefactor',0.3)
  axis equal
  axis([xmin xmax zmin zmax])
a=pcolor(Rr,Zz,inter_sigz);
caxis([-200 200])
  colormap(jet)
  color=colorbar ;
  shading interp
  alpha(a,0.5);
  v=[0.02:0.02:0.6];
  [cs, h] = contour(Rr,Zz,-inter_sigxz/loadapplied,v,'k','linewidth',1);
  clabel(cs,h)
  plot(pos_ini_r,-pos_ini_z,'bo')
  plot((Xt-0.084+0.03)*f,0,'ro')
  plot(xdel,-zdel,'r','linewidth',2)
  title('Trajectoire du dyke / Directions sigma 1')
  xlabel('x(m)')
  ylabel('z(m)')
  color.Label.String='Contrainte sigmaz (Pa)' ;
  hold off

%Trajectoire sur la valeur de sigmaxx, tout est normalis� par l'echelle de longueur Zs  
figure(1020)
hold on
 b=quiver(Rrr/pos_ini_z,Zzz/pos_ini_z,inter_dir_R_qui_norm,inter_dir_Z_qui_norm,'k');
   set(b,'showarrowhead','off')
   set(b,'autoscalefactor',0.3)
  axis([xmin/pos_ini_z xmax/pos_ini_z zmin/pos_ini_z zmax/pos_ini_z])
%axis([-1.44 0 -1 0])

a=pcolor(Rr/pos_ini_z,Zz/pos_ini_z,inter_sigx);
caxis([-200 200])
  colormap(jet)
  color=colorbar ;
  shading interp
  alpha(a,0.5);
  plot(pos_ini_r/pos_ini_z,-pos_ini_z/pos_ini_z,'bo')
  plot(xdel/pos_ini_z,-zdel/pos_ini_z,'r','linewidth',2)
  title('Trajectoire du dyke / Directions sigma 1')
  xlabel('x nromalis�')
  ylabel('z normalis�')
  color.Label.String='Contrainte sigmax (Pa)' ;  
  hold off
  

  
  %%%%%%%%%%%%%%%
  
% figure pour comparer mes valeurs interpol�es et mes valeurs initiales
  figure(1003)
 subplot(2,3,1)
 plot(x,-z)
 hold on
 plot(xtrue,-ztrue,'r')
 title('position du dyke')
 xlabel('r(m)')
 ylabel('z(m)')
 hold off

 subplot(2,3,2);
plot(d,sig3plo)
hold on
plot(dtrue,pos_sig3,'r')
title('sigma3')
xlabel('longueur dykle(m)')
ylabel('sigma3 (Pa)')
hold off

subplot(2,3,3);
plot(d,diff_sig3)
hold on
title('d(sigma3)/dl')
xlabel('longueur du dyke(m)')
ylabel('d(sigma)/dl')
hold off

subplot(2,3,4);
plot(d,diff2_sig3)
hold on
title('d²(sima3)/dl²')
xlabel('longueur du dyke(m)')
ylabel('d²(sigma3)/dl²')
hold off

subplot(2,3,5);
plot(d,diffz)
hold on
title('dz/dl')
xlabel('longueur du dyke(m)')
ylabel('dz/dl')
hold off

subplot(2,3,6);
plot(d,diff2z)
hold on
title('d²z/dl²')
xlabel('longueur du dyke(m)')
ylabel('d²z/dl²')
hold off


%figure pour comparer mes valeurs interpol�es et mes valeurs initiales pour
%la contrainte normale
figure(1005)
hold on
plot(pos_sig3,-ztrue*100,'.r')
plot(sig3plo,-z*100)
hold off



figure(1006)
sig3ref=sig3plo(1)*ones(size(sig3plo));
sig3norm=(sig3plo-sig3ref)*100./sig3ref;
hold on
plot(sig3norm,-z*100)
hold off
%save('contrNorm.txt','sig3norm','-ascii','-double')
%cela sort la contrainte normale normalis�e par la valeur en zero....
%lire entrposz et cela et faire plot(sig3norm,-z)


%theta (angle par rapport � la vertical en radian) obtenu avec la trajectoire interpol�e
figure(1007)
hold on
plot(theta,-z*100,'r')
hold off

